// Auxiliary functions 

void unvec(int n , int m, double *vecmatrix, double matrix[n][m])  {
  // unvec takes a array vecmarix (which should be of size n*m) and unvecs it
  // staking by column
  // output is passed to pointer matrix

  int i,j;

  for (j=0; j<m; j++) {
    for (i=0; i<n; i++) {
      matrix[i][j] = vecmatrix[i+j*n];
    }
  }
}

void unvecc(int n , int m, double vecmatrix[n*m], double matrix[n][m])  {
  // unvec takes a array vecmarix (which should be of size n*m) and unvecs it
  // staking by column
  // output is passed to pointer matrix

  int i,j;

  for (j=0; j<m; j++) {
    for (i=0; i<n; i++) {
      matrix[i][j] = vecmatrix[i+j*n];
    }
  }
}

void vec(int n , int m, double matrix[n][m], double vecmatrix[n*m])  
{
  int i,j;

  for (j=0; j<m; j++) {
    for (i=0; i<n; i++) {
      vecmatrix[i+j*n] = matrix[i][j];
    }
  }
}

void vectorize(int n , int m, double matrix[n][m], double *vecmatrix)  
{
  int i,j;

  for (j=0; j<m; j++) {
    for (i=0; i<n; i++) {
      vecmatrix[i+j*n] = matrix[i][j];
    }
  }
}

void unvecbyrow(int n , int m, double *vecmatrix, double matrix[n][m])  {
  // unvec takes a array vecmarix (which should be of size n*m) and unvecs it
  // staking by row
  // output is passed to pointer matrix

  int i,j;

  for (i=0; i<n; i++) {
    for (j=0; j<m; j++) {
      matrix[i][j] = vecmatrix[j+i*m];
    }
  }
}

void printvec(int n, double *x)

/* sum array x up */
{
    int i;
    
    for(i=0;i<n;i++) {
      printf("%.10f\n",(double) x[i]);
    }

}

void printintvec(int n, int *x)

/* sum array x up */
{
    int i;
    
    for(i=0;i<n;i++) {
	printf("%d\n",x[i]);
    }

}

void printmatrix(int n, int p, double mat[n][p])

/* sum array x up */
{
  int i,j;
    
    for(i=0;i<n;i++) 
      for (j=0;j<p;j++)
	printf("(%d,%d) matrix value is %f\n",i,j,mat[i][j]);
}

void printpartofmatrix(int M, int N, int mm, int nn, double mat[M][N])

/* sum array x up */
{
  int i,j;
    
    for(i=0;i<mm;i++) 
      for (j=0;j<nn;j++)
	printf("(%d,%d) matrix value is %f\n",i,j,mat[i][j]);
}

// function fills in X with simulated values
void fillXmatrix(int n , int p1, int p2, double Zmat[n][p1], double Zmissmat[n][p1], 
	      double Xmat[n][p2], int nmiss, double missobs[nmiss], double filledXmatrix[n][p1+p2])
{
  int i,j,k=0;
  double tmp;
  for(i=0;i<n;i++) {
    for (j=0;j<p1;j++) {
      if ( (int) Zmissmat[i][j] == 1)  { 
	//printf("%d=%d\n",i,j);
	tmp = missobs[k];
	k++;
      }
      else 
	tmp = Zmat[i][j];
      filledXmatrix[i][j] = tmp;
    }
    for (j=p1;j<p1+p2;j++)
      filledXmatrix[i][j] = Xmat[i][j-p1];
  }
}

double sum (int n, double *x)
{
  double total;
  int i;
  for (i=0,total=0.0;i<n;i++)  
    total += (double) x[i];
  return(total);
}

int sum_int (int n, int *x)
{
  int i,total;
  for (i=0,total=0;i<n;i++)  
    total += x[i];
  return(total);
}

// function fills in X with simulated values
void fillZmatrix(int n , int p1, double Zmat[n][p1], double Zmissmat[n][p1], 
		 int nmiss, double missobs[nmiss], double filledZmatrix[n][p1])
{
  int i,j,k;
  double tmp;
  
  k=0;
  for(i=0;i<n;i++) {
    //if ((int) sum(p1,Zmissmat[i]) == 0)  {
    //  filledZmatrix[i] = Zmat[i];
    //  continue;
    //}
    for (j=0;j<p1;j++) {
      if ((int) Zmissmat[i][j] == 1)  { 
	//printf("%d=%d\n",i,j);
	tmp = missobs[k];
	k++;
      }
      else 
	tmp = Zmat[i][j];
      filledZmatrix[i][j] = tmp;
    }
  }
}

// function fills in X with simulated values
void setmatrixto0(int n , int m, double X[n][m])
{
  int i,j;
  for(i=0;i<n;i++) 
    for (j=0;j<m;j++) 
      X[i][j] =0;

}



// function fills in X with simulated values
void setvectorto0(int n ,double X[n])
{
  int i;
  for(i=0;i<n;i++) 
      X[i] = 0;

}

// function fills in X with simulated values
void set3darrayto0(int n , int m, int o, double X[n][m][o])
{
  int i,j,k;
  for(i=0;i<n;i++) 
    for (j=0;j<m;j++)
      for (k=0; k<o; k++)
	X[i][j][k] = 0;
}

// function fills in X with simulated values
void ifelse(int n , int logic[n], double iftrue[n], double iffalse[n], double out[n])
{
  int i;
  for (i=0;i<n;i++)
    out[i] = (logic[i]) ? iftrue[i]: iffalse[i];

}

// readfile reads all the elements in file and spits them to data, ntotal is total number of elements
void readfile(char **file, int ntotal, double data[ntotal])
{
  FILE *f;
  int i;

  f = fopen(*file,"r");
  if (f == NULL) 
    printf("Error can't open file");
  i=0;
  while(!feof(f))  {
    fscanf(f,"%lf",&data[i]);
    i++;
  }
  fclose(f);
}

    
// function fills in X with simulated values
void ps()
{
  printf("I am here\n");
}

double inverselogit(double x)
{
  double out;
  out = 1.0/(1.0+exp(-x));
  return out;
}

void copyvec(int n, double *x, double *y)
{
  int i;
  for (i=0;i<n;i++)
    y[i] = x[i];
}

void copyvec_int(int n, int *x, int *y)
{
  int i;
  for (i=0;i<n;i++)
    y[i] = x[i];
}

double max(int n, double *x)
{
  int i;
  double out;
  out = x[0];
  for (i=0;i<n;i++)  {
    out = (x[i] > out) ? x[i] : out;
  }
  return(out);
}

int max_int(int n, int *x)
{
  int i;
  int out;
  out = x[0];
  for (i=0;i<n;i++)  {
    out = (x[i] > out) ? x[i] : out;
  }
  return(out);
}
