## to run lmqrun in university cluster, asking for 3 variables mod,group,whichgroup

args <- commandArgs()
args <- args[5:length(args)]
args <- gsub("-","",args)
args <- strsplit(args,"=")

for (i in 1:length(args))  {
  x <- args[[i]]
  print(x[1])
  print(x[2])
  assign(x[1], as.numeric(x[2]))
}

source("lmeqfit.r")
##mod <- 1; group <- 1; whichgroup <- 1;
#debug(lmeqfit)

datafilenames <- c("datan50sigma3","datan50sigma1", "datan100sigma3","datan100sigma1", "datan200sigma3","datan200sigma1")
datafilenames <- paste(datafilenames,"20090916",sep="")
                       
## lets call the above models 1:6 and pick the one we want to run
## which group should go from 
datafilenames <- datafilenames[mod]
load(paste(datafilenames,".rdata",sep=""))
extract <- ((whichgroup-1)*group+1):(whichgroup*group)
datasets <- datasets[extract]

## following penalty parameters values estimated from initial simulations
control <- list(relativeerror=.05,maxiter=33)
penalty.start.scad <- list(c(.08,.11),c(.35,.25),c(.05,.10),c(.25,.25),c(.02,.09),c(.13,.15))
penalty.start.lasso <- list(c(.02,.10),c(.05,.10),c(.02,.08),c(.05,.25),c(.005,.05),c(.005,.18))
penalty.start.alasso <- list(c(.03,.04),c(.05,.05),c(.01,.03),c(.01 ,.04),c(.005,.025),c(.005,.03))
names(penalty.start.scad) <- names(penalty.start.alasso) <- names(penalty.start.lasso) <- datafilenames
p <- 8
q <- 8
penalize <- c(rep(TRUE,p),rep(TRUE,q*(q+1)/2))
for (model in datafilenames)  {
  cat("Estimating model",model,"at",date(),"\n")
  input.lasso <- list(penalty.fun=alasso,scalemle=TRUE,penalty.start=penalty.start.lasso[[model]])
  input.alasso <- list(penalty.fun=alasso,scalemle=TRUE,penalty.start=penalty.start.alasso[[model]])
  input.scad <- list(penalty.fun=scad,scalemle=FALSE,penalty.start=penalty.start.scad[[model]])
  input <- list(lasso=input.lasso,alasso1=input.alasso,alasso2=input.alasso,scad=input.scad,nsim=500,penalize=penalize)
  out <- lmeqoverallfit(datasets,input,control)
  save(out,file=paste("out",model,"group",whichgroup,gsub("-","",Sys.Date(),extended=TRUE),".rdata",sep=""))
}

### the files produces by cluster moved to folder simoutput










