#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "lmeqsim.c"

void lmeq1_fun_m(double *theta, void *fundata, double *out)
{
  struct data_glmme *mydata;
  mydata = fundata;

  lmeq1_fun(theta,mydata->phi,mydata->y,mydata->X,mydata->Z,mydata->bmean,mydata->bvar,mydata->n,mydata->p,mydata->q,mydata->ni,out);
}

void lmeq1_grad_m(double *theta, void *fundata, double *out)
{
  struct data_glmme *mydata;
  mydata = fundata;

  lmeq1_grad(theta,mydata->phi,mydata->y,mydata->X,mydata->Z,mydata->bmean,mydata->bvar,mydata->n,mydata->p,mydata->q,mydata->ni,out);

}

void lmeq1_hess_m(double *theta, void *fundata, double *out)
{
  struct data_glmme *mydata;
  mydata = fundata;

  lmeq1_hess(theta,mydata->phi,mydata->y,mydata->X,mydata->Z,mydata->bmean,mydata->bvar,mydata->n,mydata->p,mydata->q,mydata->ni,out);

}

void nexttheta_mle_lmeq1(double *theta, double *phi, double *y, double *X, double *Z, double *bmean, double *bvar, int *n, int *p, int *q, int *ni, 
			 double *out)

{
  int truep[1];
  truep[0] = *p+*q*(*q+1)/2;
  struct data_glmme mydata;
  mydata.theta=theta;
  mydata.phi=phi;
  mydata.y=y;
  mydata.X=X;
  mydata.Z=Z;
  mydata.bmean=bmean;
  mydata.bvar=bvar;
  mydata.n=n;
  mydata.p=p;
  mydata.q=q;
  mydata.ni=ni;
  lmeq1_grad_m(theta,&mydata,out);
  //vp(truep[0],out,"out");
  //ps();
  //return;
  //double outy[truep[0]*truep[0]];
  //lmeq1_hess_m(theta,&mydata,outy);
  //ps();
  //return;
  //vp(truep[0]*truep[0],outy,"outy");
  //return;
  nextbeta_mle(theta,lmeq1_grad_m,lmeq1_hess_m,&mydata,&(truep[0]),out);
}

void nexttheta_grouplqa_scad_lmeq1(double *theta, double *phi, double *y, double *X, double *Z, double *bmean, double *bvar, int *n, int *p, int *q, 
				   int *ni, double *penalize, double *penalty, int *groupindex, int *numgroup, double *out)
{
  int truep[1];
  truep[0] = *p+*q*(*q+1)/2;
  struct data_glmme mydata;
  mydata.theta=theta;
  mydata.phi=phi;
  mydata.y=y;
  mydata.X=X;
  mydata.Z=Z;
  mydata.bmean=bmean;
  mydata.bvar=bvar;
  mydata.n=n;
  mydata.p=p;
  mydata.q=q;
  mydata.ni=ni;
  lmeq1_grad_m(theta,&mydata,out);
  //vp(truep[0],out,"out");
  //double outy[truep[0]*truep[0]];
  //lmeq1_hess_m(theta,&mydata,outy);
  //vp(truep[0]*truep[0],outy,"outy");
  int sni[1]; 
  sni[0]=*n;
  //sni[0]=*n;
  nextbeta_grouplqa(theta,lmeq1_grad_m,lmeq1_hess_m,&mydata,&(truep[0]),sni,penalize,penalty,groupindex,numgroup,scadpenalty_gradient,out);
}

void nexttheta_grouplqa_lasso_lmeq1(double *theta, double *phi, double *y, double *X, double *Z, double *bmean, double *bvar, int *n, 
				    int *p, int *q, int *ni,
				    double *penalize, double *penalty, int *groupindex, int *numgroup, double *out)
{
  int truep[1];
  truep[0] = *p+*q*(*q+1)/2;
  struct data_glmme mydata;
  mydata.theta=theta;
  mydata.phi=phi;
  mydata.y=y;
  mydata.X=X;
  mydata.Z=Z;
  mydata.bmean=bmean;
  mydata.bvar=bvar;
  mydata.n=n;
  mydata.p=p;
  mydata.q=q;
  mydata.ni=ni;
  //lmeq1_grad_m(theta,&mydata,out);
  //vp(truep[0],out,"out");
  //double outy[truep[0]*truep[0]];
  //lmeq1_hess_m(theta,&mydata,outy);
  //vp(truep[0]*truep[0],outy,"outy");
  int sni[1];
  //sni[0]=*n;
  sni[0]=*n;
  nextbeta_grouplqa(theta,lmeq1_grad_m,lmeq1_hess_m,&mydata,&(truep[0]),sni,penalize,penalty,groupindex,numgroup,lassopenalty_gradient,out);
}

void nexttheta_grouplla_lasso_lmeq1(double *theta, double *phi, double *y, 
				    double *X, double *Z, double *bmean, double *bvar, int *n, int *p, int *q, int *ni,
				    double *penalize, double *penalty, int *groupindex, int *numgroup, double *out)
{
  int truep[1];
  truep[0] = *p+*q*(*q+1)/2;
  struct data_glmme mydata;
  mydata.theta=theta;
  mydata.phi=phi;
  mydata.y=y;
  mydata.X=X;
  mydata.Z=Z;
  mydata.bmean=bmean;
  mydata.bvar=bvar;
  mydata.n=n;
  mydata.p=p;
  mydata.q=q;
  mydata.ni=ni;
  double grad[truep[0]],hess[truep[0]*truep[0]];
  lmeq1_grad_m(theta,&mydata,grad);
  lmeq1_hess_m(theta,&mydata,hess);
  //vp(truep[0],out,"out");
  //double outy[truep[0]*truep[0]];
  //vp(truep[0]*truep[0],outy,"outy");
  int sni[1];
  sni[0]=*n;
  //sni[0]=*n;
  // if there are groups wich are all zero then
  // lets restart with subset of problem
  int length[truep[0]],i,j;
  double distance[truep[0]];
  groupdistance(theta,&(truep[0]),groupindex,numgroup,length,distance);
  int not0[truep[0]],sumnot0[1],numgroupnew[1],tmpint,tmpint2;
  for (i=0;i<truep[0];i++)  
    not0[i]= (distance[i]==0) ? 0 : 1;
  sumnot0[0]=sum_int(truep[0],not0);
  if (sumnot0[0]>0)  {
    int groupindexnew[sumnot0[0]],maxint;
    double thetanew[sumnot0[0]],gradnew[sumnot0[0]],penalizenew[sumnot0[0]],hessnew[sumnot0[0]*sumnot0[0]],outy[sumnot0[0]],
      penaltynew[sumnot0[0]];
    for (i=0,tmpint=0;i<truep[0];i++)  {
      if (not0[i]==1)  {
	thetanew[tmpint]=theta[i];
	gradnew[tmpint]=grad[i];
	groupindexnew[tmpint]=groupindex[i];
	penalizenew[tmpint]=penalize[i];
	penaltynew[tmpint]=penalty[i];
	for (j=0,tmpint2=0;j<truep[0];j++)  {
	  if (not0[j]==1)  {
	    hessnew[tmpint+sumnot0[0]*tmpint2] = hess[i+truep[0]*j];
	    tmpint2++;
	  }
	}
	tmpint++;
      }
    }
    for (i=0,numgroupnew[0]=0;i<numgroup[0];i++)  {
      for (j=0,tmpint=0;j<sumnot0[0];j++)  
	if (groupindexnew[j]==i)
	  tmpint++;
      if (tmpint>0) 
	numgroupnew[0]++;
    }
    for (i=0;i<numgroupnew[0];i++)  {
      //printf("At iteration %d\n",i);
      //ivp(sumnot0[0],groupindexnew,"groupindexnew");
      for (j=0,tmpint=0;j<sumnot0[0];j++)  
	if (groupindexnew[j]==i)
	  tmpint++;
      if (tmpint==0)  {
	maxint=max_int(sumnot0[0],groupindexnew);
	for (j=0;j<sumnot0[0];j++)  {
	  groupindexnew[j] = (groupindexnew[j]==maxint) ? i : groupindexnew[j];
	}
      }
    }
    //ps();
    //ivp(truep[0],groupindex,"groupindex");
    //printf("numgroup=%d,numgroupnew=%d\n",numgroup[0],numgroupnew[0]);
    //ivp(sumnot0[0],groupindexnew,"groupindexnew");
    //vp(sumnot0[0],thetanew,"thetanew");
    //vp(sumnot0[0],gradnew,"gradnew");
    //vp(sumnot0[0]*sumnot0[0],hessnew,"hessnew");
    nextbeta_grouplla(thetanew,gradnew,hessnew,sumnot0,sni,penalizenew,penaltynew,groupindexnew,numgroupnew,lassopenalty_gradient,outy);
    //vp(sumnot0[0],outy,"outy");
    for (i=0,tmpint=0;i<truep[0];i++)  
      out[i] = (not0[i]==1) ? outy[tmpint++] : 0; 
  } else {
    nextbeta_grouplla(theta,grad,hess,&(truep[0]),sni,penalize,penalty,groupindex,numgroup,lassopenalty_gradient,out);
  }
}


void nexttheta_grouplla_scad_lmeq1(double *theta, double *phi, double *y, 
				    double *X, double *Z, double *bmean, double *bvar, int *n, int *p, int *q, int *ni,
				    double *penalize, double *penalty, int *groupindex, int *numgroup, double *out)
{
  int truep[1];
  truep[0] = *p+*q*(*q+1)/2;
  struct data_glmme mydata;
  mydata.theta=theta;
  mydata.phi=phi;
  mydata.y=y;
  mydata.X=X;
  mydata.Z=Z;
  mydata.bmean=bmean;
  mydata.bvar=bvar;
  mydata.n=n;
  mydata.p=p;
  mydata.q=q;
  mydata.ni=ni;
  double grad[truep[0]],hess[truep[0]*truep[0]];
  lmeq1_grad_m(theta,&mydata,grad);
  lmeq1_hess_m(theta,&mydata,hess);
  //vp(truep[0],out,"out");
  //double outy[truep[0]*truep[0]];
  //vp(truep[0]*truep[0],outy,"outy");
  int sni[1];
  sni[0]=*n;
  //sni[0]=*n;
  // if there are groups wich are all zero then
  // lets restart with subset of problem
  int length[truep[0]],i,j;
  double distance[truep[0]];
  groupdistance(theta,&(truep[0]),groupindex,numgroup,length,distance);
  int not0[truep[0]],sumnot0[1],numgroupnew[1],tmpint,tmpint2;
  for (i=0;i<truep[0];i++)  
    not0[i]= (distance[i]==0) ? 0 : 1;
  sumnot0[0]=sum_int(truep[0],not0);
  if (sumnot0[0]>0)  {
    int groupindexnew[sumnot0[0]],maxint;
    double thetanew[sumnot0[0]],gradnew[sumnot0[0]],penalizenew[sumnot0[0]],hessnew[sumnot0[0]*sumnot0[0]],outy[sumnot0[0]],
      penaltynew[sumnot0[0]];
    for (i=0,tmpint=0;i<truep[0];i++)  {
      if (not0[i]==1)  {
	thetanew[tmpint]=theta[i];
	gradnew[tmpint]=grad[i];
	groupindexnew[tmpint]=groupindex[i];
	penalizenew[tmpint]=penalize[i];
	penaltynew[tmpint]=penalty[i];
	for (j=0,tmpint2=0;j<truep[0];j++)  {
	  if (not0[j]==1)  {
	    hessnew[tmpint+sumnot0[0]*tmpint2] = hess[i+truep[0]*j];
	    tmpint2++;
	  }
	}
	tmpint++;
      }
    }
    for (i=0,numgroupnew[0]=0;i<numgroup[0];i++)  {
      for (j=0,tmpint=0;j<sumnot0[0];j++)  
	if (groupindexnew[j]==i)
	  tmpint++;
      if (tmpint>0) 
	numgroupnew[0]++;
    }
    for (i=0;i<numgroupnew[0];i++)  {
      //printf("At iteration %d\n",i);
      //ivp(sumnot0[0],groupindexnew,"groupindexnew");
      for (j=0,tmpint=0;j<sumnot0[0];j++)  
	if (groupindexnew[j]==i)
	  tmpint++;
      if (tmpint==0)  {
	maxint=max_int(sumnot0[0],groupindexnew);
	for (j=0;j<sumnot0[0];j++)  {
	  groupindexnew[j] = (groupindexnew[j]==maxint) ? i : groupindexnew[j];
	}
      }
    }
    //ps();
    //ivp(truep[0],groupindex,"groupindex");
    //printf("numgroup=%d,numgroupnew=%d\n",numgroup[0],numgroupnew[0]);
    //ivp(sumnot0[0],groupindexnew,"groupindexnew");
    //vp(sumnot0[0],thetanew,"thetanew");
    //vp(sumnot0[0],gradnew,"gradnew");
    //vp(sumnot0[0]*sumnot0[0],hessnew,"hessnew");
    nextbeta_grouplla(thetanew,gradnew,hessnew,sumnot0,sni,penalizenew,penaltynew,groupindexnew,numgroupnew,scadpenalty_gradient,outy);
    //vp(sumnot0[0],outy,"outy");
    for (i=0,tmpint=0;i<truep[0];i++)  
      out[i] = (not0[i]==1) ? outy[tmpint++] : 0; 
  } else {
    nextbeta_grouplla(theta,grad,hess,&(truep[0]),sni,penalize,penalty,groupindex,numgroup,scadpenalty_gradient,out);
  }
}

