
## sumarizes simulations from lmqrun, simply supply out .rdata file names form these runs and summaries should spit
source("missing.r")
source("lme_auxfun.r")
betatrue <- c(3,2,1.5,0,0,0,0,0)
p <- 8
q <- 8
p.true <- q.true <- 3
tmp <- Sigmaxxcorr(.5,q.true)
tmpy <- matrix(0,q,q)
tmpy[1:q.true,1:q.true] <- tmp
Dtrue <- tmpy
## tmpy <- matrix(0,q.true,3)
## tmp <- chol(tmp)
## tmpy[1:2,1:2] <- t(tmp)
## mtrue <- ltvec(tmpy)
reeq0 <- c(rep(FALSE,3),rep(TRUE,5))

mse <- function(theta)  {
  m <- c(unlist(theta[(p+1):(p+q*(q+1)/2),]))
  D <- opltv(m)
  tmp <- (Dtrue-D)
  out <- sum(sqrt(tmp^2))
  out
}

## mse <- function(theta)  {
##   m <- c(unlist(theta[(p+1):(p+q*(q+1)/2),]))
##   out <- crossprod(m-mtrue)
##   out
## }

## mse <- function(theta)  {
##   m <- c(unlist(theta[(p+1):(p+q*(q+1)/2),]))
##   out <- crossprod(m-mtrue)
##   out
## }


rmse <- function(x,penaltyfun.name,penaltyest.name)  {
  theta <- x[[penaltyfun.name]][[penaltyest.name]]$theta
  mle <- x[["mle"]]$theta
  out <- mse(theta)/mse(mle)
  out
}
rmse.oracle <- function(x)  {
  mle <- x[["mle"]]$theta
  beta <- x[["oracle"]]$theta
  theta <- matrix(rep(0,p+q*(q+1)/2),,1)
  theta[1:q.true,] <- beta[1:q.true,]
  mat <- matrix(0,q,q)
  mat[1:q.true,1:q.true] <- ltmat(beta[(p.true+1):(p.true+q.true*(q.true+1)/2),])
  theta[(p+1):(p+q*(q+1)/2),] <- ltvec(mat)
  out <- mse(theta)/mse(mle)
  out
}

incorrectzero <- function(x,penaltyfun.name,penaltyest.name)  {
  theta <- x[[penaltyfun.name]][[penaltyest.name]]$theta
  m <- theta[(p+1):(p+q*(q+1)/2),1,drop=FALSE]
  D <- opltv(m)
  out <- sum(diag(D)[!reeq0]==0)/q.true
  out
}

incorrectnonzero <- function(x,penaltyfun.name,penaltyest.name)  {
  theta <- x[[penaltyfun.name]][[penaltyest.name]]$theta
  m <- theta[(p+1):(p+q*(q+1)/2),1,drop=FALSE]
  D <- opltv(m)
  out <- sum(diag(D)[reeq0]!=0)/(q-q.true)
  out
}

penaltyest <- function(x,penaltyfun.name,penaltyest.name)  {
  out <- x[[penaltyfun.name]][[penaltyest.name]]$penalty
  ##if (penaltyest.name=="re") out <- out[2]
  out
}


summarizesims <- function(rdatafilename)  {
  load(rdatafilename)
  mrme.scad.icq <- median(sapply(out,rmse,penaltyfun.name="scad",penaltyest.name="icq"))
  mrme.scad.re <- median(sapply(out,rmse,penaltyfun.name="scad",penaltyest.name="re"))
  mrme.lasso.icq <- median(sapply(out,rmse,penaltyfun.name="lasso",penaltyest.name="icq"))
  mrme.lasso.re <- median(sapply(out,rmse,penaltyfun.name="lasso",penaltyest.name="re"))  
  mrme.alasso1.icq <- median(sapply(out,rmse,penaltyfun.name="alasso1",penaltyest.name="icq"))
  mrme.alasso1.re <- median(sapply(out,rmse,penaltyfun.name="alasso1",penaltyest.name="re"))
  ##mrme.alasso2.icq <- median(sapply(out,rmse,penaltyfun.name="alasso2",penaltyest.name="icq"))
  ##mrme.alasso2.re <- median(sapply(out,rmse,penaltyfun.name="alasso2",penaltyest.name="re"))
  mrme.oracle <- median(sapply(out,rmse.oracle))
  incorrectnonzero.scad.icq <- mean(sapply(out,incorrectnonzero,penaltyfun.name="scad",penaltyest.name="icq"))
  incorrectnonzero.scad.re <- mean(sapply(out,incorrectnonzero,penaltyfun.name="scad",penaltyest.name="re"))
  incorrectnonzero.lasso.icq <- mean(sapply(out,incorrectnonzero,penaltyfun.name="lasso",penaltyest.name="icq"))
  incorrectnonzero.lasso.re <- mean(sapply(out,incorrectnonzero,penaltyfun.name="lasso",penaltyest.name="re"))
  incorrectnonzero.alasso1.icq <- mean(sapply(out,incorrectnonzero,penaltyfun.name="alasso1",penaltyest.name="icq"))
  incorrectnonzero.alasso1.re <- mean(sapply(out,incorrectnonzero,penaltyfun.name="alasso1",penaltyest.name="re"))
  ##incorrectnonzero.alasso2.icq <- mean(sapply(out,incorrectnonzero,penaltyfun.name="alasso2",penaltyest.name="icq"))
  ##incorrectnonzero.alasso2.re <- mean(sapply(out,incorrectnonzero,penaltyfun.name="alasso2",penaltyest.name="re"))  
  incorrectzero.scad.icq <- mean(sapply(out,incorrectzero,penaltyfun.name="scad",penaltyest.name="icq"))
  incorrectzero.scad.re <- mean(sapply(out,incorrectzero,penaltyfun.name="scad",penaltyest.name="re"))
  incorrectzero.lasso.icq <- mean(sapply(out,incorrectzero,penaltyfun.name="lasso",penaltyest.name="icq"))
  incorrectzero.lasso.re <- mean(sapply(out,incorrectzero,penaltyfun.name="lasso",penaltyest.name="re"))
  incorrectzero.alasso1.icq <- mean(sapply(out,incorrectzero,penaltyfun.name="alasso1",penaltyest.name="icq"))
  incorrectzero.alasso1.re <- mean(sapply(out,incorrectzero,penaltyfun.name="alasso1",penaltyest.name="re"))
  ##incorrectzero.alasso2.icq <- mean(sapply(out,incorrectzero,penaltyfun.name="alasso2",penaltyest.name="icq"))
  ##incorrectzero.alasso2.re <- mean(sapply(out,incorrectzero,penaltyfun.name="alasso2",penaltyest.name="re"))
  pe.scad.icq <- apply(sapply(out,penaltyest,penaltyfun.name="scad",penaltyest.name="icq"),1,median)
  pe.scad.re <- apply(sapply(out,penaltyest,penaltyfun.name="scad",penaltyest.name="re"),1,median)
  pe.lasso.icq <- apply(sapply(out,penaltyest,penaltyfun.name="lasso",penaltyest.name="icq"),1,median)
  pe.lasso.re <- apply(sapply(out,penaltyest,penaltyfun.name="lasso",penaltyest.name="re"),1,median)
  pe.alasso1.icq <- apply(sapply(out,penaltyest,penaltyfun.name="alasso1",penaltyest.name="icq"),1,median)
  pe.alasso1.re <- apply(sapply(out,penaltyest,penaltyfun.name="alasso1",penaltyest.name="re"),1,median)
  ##pe.alasso2.icq <- median(sapply(out,penaltyest,penaltyfun.name="alasso2",penaltyest.name="icq"))
  ##pe.alasso2.re <- median(sapply(out,penaltyest,penaltyfun.name="alasso2",penaltyest.name="re"))
  cat(paste("Rdata file is ",rdatafilename),sep="\n")
  cat(paste("Num of datasets is",length(out)),"\n")
  cat(paste("Median Relative Model Error for Scad with RE penalty estimation is ",mrme.scad.re,sep=),"\n")
  cat(paste("Median Relative Model Error for Scad with ICQ penalty estimation is ",mrme.scad.icq),"\n")
  cat(paste("Median Relative Model Error for lasso with RE penalty estimation is ",mrme.lasso.re),"\n")
  cat(paste("Median Relative Model Error for lasso with ICQ penalty estimation is ",mrme.lasso.icq),"\n")
  cat(paste("Median Relative Model Error for Alasso1 with RE penalty estimation is ",mrme.alasso1.re),"\n")
  cat(paste("Median Relative Model Error for Alasso1 with ICQ penalty estimation is ",mrme.alasso1.icq),"\n")
  ##cat(paste("Median Relative Model Error for Alasso2 with RE penalty estimation is ",mrme.alasso2.re),"\n")
  ##cat(paste("Median Relative Model Error for Alasso2 with ICQ penalty estimation is ",mrme.alasso2.icq),"\n")  
  cat(paste("Median Relative Model Error for Oracle is ",mrme.oracle),"\n")
  cat(paste("Mean Num of coefficients incorrectly estimated to be nonzero for Scad with RE penalty estimations is",
            round(incorrectnonzero.scad.re,3)),"\n")
  cat(paste("Mean Num of coefficients incorrectly estimated to be nonzero for Scad with ICQ penalty estimations is",
            round(incorrectnonzero.scad.icq,3)),"\n") 
  cat(paste("Mean Num of coefficients incorrectly estimated to be nonzero for Lasso with RE penalty estimations is",
           incorrectnonzero.lasso.re),"\n") 
  cat(paste("Mean Num of coefficients incorrectly estimated to be nonzero for Lasso with ICQ penalty estimations is",
           incorrectnonzero.lasso.icq),"\n")
  cat(paste("Mean Num of coefficients incorrectly estimated to be nonzero for Alasso1 with RE penalty estimations is",
           incorrectnonzero.alasso1.re),"\n") 
  cat(paste("Mean Num of coefficients incorrectly estimated to be nonzero for Alasso1 with ICQ penalty estimations is",
           incorrectnonzero.alasso1.icq),"\n")
  ##cat(paste("Mean Num of coefficients incorrectly estimated to be nonzero for Alasso2 with RE penalty estimations is",
  ##         incorrectnonzero.alasso2.re),"\n") 
  ##cat(paste("Mean Num of coefficients incorrectly estimated to be nonzero for Alasso2 with ICQ penalty estimations is",
  ##         incorrectnonzero.alasso2.icq),"\n")   
  cat(paste("Mean Num of coefficients incorrectly estimated to be zero for Scad with RE penalty estimations is",
            incorrectzero.scad.re),"\n") 
  cat(paste("Mean Num of coefficients incorrectly estimated to be zero for Scad with ICQ penalty estimations is",
            incorrectzero.scad.icq),"\n") 
  cat(paste("Mean Num of coefficients incorrectly estimated to be zero for Lasso with RE penalty estimations is",
            incorrectzero.lasso.re),"\n") 
  cat(paste("Mean Num of coefficients incorrectly estimated to be zero for Lasso with ICQ penalty estimations is",
            incorrectzero.lasso.icq),"\n")
  cat(paste("Mean Num of coefficients incorrectly estimated to be zero for Alasso1 with RE penalty estimations is",
            incorrectzero.alasso1.re),"\n") 
  cat(paste("Mean Num of coefficients incorrectly estimated to be zero for Alasso1 with ICQ penalty estimations is",
            incorrectzero.alasso1.icq),"\n")
  ##cat(paste("Mean Num of coefficients incorrectly estimated to be zero for Alasso2 with RE penalty estimations is",
  ##          incorrectzero.alasso2.re),"\n") 
  ##cat(paste("Mean Num of coefficients incorrectly estimated to be zero for Alasso2 with ICQ penalty estimations is",
  ##          incorrectzero.alasso2.icq),"\n")  
  cat(paste("Median Penalty Estimate for Scad with RE penalty estimation is ",pe.scad.re,collapse="\n"),"\n")
  cat(paste("Median Penalty Estimate for Scad with ICQ penalty estimation is ",pe.scad.icq,collapse="\n"),"\n")
  cat(paste("Median Penalty Estimate for Lasso with RE penalty estimation is ",pe.lasso.re,collapse="\n"),"\n")
  cat(paste("Median Penalty Estimate for Lasso with ICQ penalty estimation is ",pe.lasso.icq,collapse="\n"),"\n")
  cat(paste("Median Penalty Estimate for Alasso1 with RE penalty estimation is ",pe.alasso1.re,collapse="\n"),"\n")
  cat(paste("Median Penalty Estimate for Alasso1 with ICQ penalty estimation is ",pe.alasso1.icq,collapse="\n"),"\n")
  ##cat(paste("Median Penalty Estimate for Alasso2 with RE penalty estimation is ",pe.alasso2.re),"\n")
  ##cat(paste("Median Penalty Estimate for Alasso2 with ICQ penalty estimation is ",pe.alasso2.icq),"\n")
}

combinesims <- function(name)  {
  outfn <- paste(name,".rdata",sep="")
  if (file.exists(outfn)) file.remove(outfn)
  if (is.na(grep(name,list.files())[1]))
    return (NA)
  sims <- grep(".rdata",grep(name,list.files(),value=TRUE),value=TRUE)
  load(sims[1])
  output <- out
  ##ds <- datasets
  for ( file in sims[-1])  {
    load(file)
    output <- c(output,out)
    ##ds <- c(ds,datasets)
  }
  out <- output
  ##datasets <- ds
  ##save(datasets,out, file=outfn)
  save(out, file=outfn)
  outfn
}


## debug(combinesims)
fn <- c("datan50sigma3","datan50sigma1","datan100sigma3","datan100sigma1", "datan200sigma3","datan200sigma1")
## fn <- c("datan50sigma2","datan50sigma1")
fn <- paste("out",fn,"20090916",sep="")
## debug(combinesims)
fn <- sapply(fn,combinesims)
##fn <- paste(fn,".rdata",sep="")
##debug(summarizesims)
fn <- fn[!is.na(fn)]
lapply(fn,summarizesims)
