
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

// as with lmeq.c computes GLMM for poison response model

double conanfun_pme(double x)
{
  return(x);
}

double conanfun_grad_pme(double x)
{
  return(1.0);
}

double conanfun_hess_pme(double x)
{
  return(0.0);
}

double bfun_pme(double x)
{
  return(exp(x));
}

double bfun_grad_pme(double x)
{
  return(exp(x));
}

double bfun_hess_pme(double x)
{
  return(exp(x));
}


double factorial(double n)  {
  int i;
  double out;
  for (i=1,out=1.0;i<=((int) n);i++)  {
    out=out*((double) i);
  }
  return(out);
}

double cfun_pme(double x, double *phi)
{
  double out;
  out = -log(factorial(x));
  return out;
}

void pmeq1_fun(double *theta, double *y, double *X, double *Z, double *k, int *n, int *p, int *q, int *ni, 
		 int *nsim, char **fileb, double *out)
{
  double phi[1];
  phi[0]=1.0;
  
  glmmeq1_fun(theta,phi,y,X,Z,k,n,p,q,ni,nsim,fileb,conanfun_pme,conanfun_grad_pme,conanfun_hess_pme,bfun_pme,bfun_grad_pme,
	      bfun_hess_pme,cfun_pme,out);
}

void pmeq1_grad(double *theta, double *y, double *X, double *Z, double *k, int *n, int *p, int *q, int *ni, 
		int *nsim, char **fileb, double *out)
{
  double phi[1];
  phi[0]=1.0;
  glmmeq1_grad(theta,phi,y,X,Z,k,n,p,q,ni,nsim,fileb,conanfun_pme,conanfun_grad_pme,conanfun_hess_pme,bfun_pme,bfun_grad_pme,
	       bfun_hess_pme,cfun_pme,out);
}

void pmeq1_hess(double *theta, double *y, double *X, double *Z, double *k, int *n, int *p, int *q, int *ni, 
		 int *nsim, char **fileb, double *out)
{
  double phi[1];
  phi[0]=1.0;
  glmmeq1_hess(theta,phi,y,X,Z,k,n,p,q,ni,nsim,fileb,conanfun_pme,conanfun_grad_pme,conanfun_hess_pme,bfun_pme,bfun_grad_pme,
	       bfun_hess_pme,cfun_pme,out);
}


