

#if (FALSE)  {
#args <- commandArgs()
#args <- args[5:length(args)]
#args <- gsub("-","",args)
#args <- strsplit(args,"=")

#for (i in 1:length(args))  {
#  x <- args[[i]]
#  print(x[1])
#  print(x[2])
#  assign(x[1], as.numeric(x[2]))
#}
#} else pf <- 2

library(epicalc)
#library(epicalc,lib="/netscr/rigarcia/lmeq/current")
library("lmm")
source("lmeqfit.r")


colnames <- c("id","black","nopreg","age","gender","cocaine","gestat","visit","weight")
yaleinfant <- read.table(file="yaleinfant.txt",col.names=colnames)
#yaleinfant$weight <- yaleinfant$weight-mean(yaleinfant$weight)/sqrt(var(yaleinfant$weight))
#yaleinfant$age <- (yaleinfant$age-mean(yaleinfant$age))/sqrt(var(yaleinfant$age))
#yaleinfant$gestat <- (yaleinfant$gestat-mean(yaleinfant$gestat))/sqrt(var(yaleinfant$gestat))
yaleinfant$visit <- yaleinfant$visit/sqrt(var(yaleinfant$visit))

#yaleinfant$age <- (yaleinfant$age-mean(yaleinfant$age))
#yaleinfant$gestat <- (yaleinfant$gestat-mean(yaleinfant$gestat))

id <- unique(yaleinfant$id)
yaleinfant$id <- recode(yaleinfant$id,id,1:length(id))
yaleinfant$nopreg <- ifelse(yaleinfant$nopreg==0,1,0)
yaleinfant$gender <- ifelse(yaleinfant$gender==1,1,0)

#yaleinfant$black <- (yaleinfant$black-mean(yaleinfant$black))/sqrt(var(yaleinfant$black))
#yaleinfant$nopreg <- (yaleinfant$nopreg-mean(yaleinfant$nopreg))/sqrt(var(yaleinfant$nopreg))
#yaleinfant$gender <- (yaleinfant$gender-mean(yaleinfant$gender))/sqrt(var(yaleinfant$gender))
#yaleinfant$cocaine <- (yaleinfant$cocaine-mean(yaleinfant$cocaine))/sqrt(var(yaleinfant$cocaine))

id <- unique(yaleinfant$id)
y <- X <- Z <- list()

for ( ids in id)  {
  y[[ids]] <- matrix(subset(yaleinfant,subset=id==ids)$weight,ncol=1)
  X[[ids]] <- cbind(1,matrix(as.matrix(subset(yaleinfant,subset=id==ids)[,c("visit","age","gestat","black","nopreg",
	"gender","cocaine")]),ncol=7))
  Z[[ids]] <- cbind(1,matrix(as.matrix(subset(yaleinfant,subset=id==ids)[,c("visit","age","gestat")]),ncol=3))
}

#tmp <- do.call("rbind",lapply(1:length(X),function(i) X[[i]][1,]))
#tmp <- as.data.frame(tmp)
#yaley <- tmp
#colnames(yaley) <- c("1","black","nopreg","age","gender","cocaine","gestat","visit")

### mle analysis
out.mle1 <- lme(weight~+visit+age+gestat+black+nopreg+gender+cocaine,random=list(id=~1+visit+age+gestat),method="ML",
data=yaleinfant,control=lmeControl(maxIter=100,tolerance=1e-5,opt="optim"))
out.mle2 <- lme(weight~+visit+age+gestat+black+nopreg+gender+cocaine,random=list(id=~1+age+gestat),method="ML",
data=yaleinfant,control=lmeControl(maxIter=100,tolerance=1e-5,opt="optim"))
out.mle3 <- lme(weight~+visit+age+gestat+black+nopreg+gender+cocaine,random=list(id=~1+visit+gestat),method="ML",
data=yaleinfant,control=lmeControl(maxIter=100,tolerance=1e-5,opt="optim"))
out.mle4 <- lme(weight~+visit+age+gestat+black+nopreg+gender+cocaine,random=list(id=~1+visit+age),method="ML",
data=yaleinfant,control=lmeControl(maxIter=100,tolerance=1e-5,opt="optim"))
out.mle5 <- lme(weight~+visit+age+gestat+black+nopreg+gender+cocaine,random=list(id=~1+visit),method="ML",
data=yaleinfant,control=lmeControl(maxIter=100,tolerance=1e-5,opt="optim"))
out.mle6 <- lme(weight~+visit+age+gestat+black+nopreg+gender+cocaine,random=list(id=~1),method="ML",
data=yaleinfant,control=lmeControl(maxIter=100,tolerance=1e-5,opt="optim"))
out.mle7 <- lme(weight~+visit+gestat+gender+cocaine,random=list(id=~1+visit),method="ML",
data=yaleinfant,control=lmeControl(maxIter=100,tolerance=1e-5,opt="optim"))

browser()

control <- list(relativeerror=.01,maxiter=20)
p <- 8
q <- 4
penalize <- c(rep(TRUE,p),rep(TRUE,q*(q+1)/2))
n <- length(y)
ni <- sapply(y,nrow)
datasets <- list()

datasets[[1]] <- list(y=y,X=X,Z=Z,n=n,ni=ni,p=p,q=q)

penalty.start.lasso <- c(.3,1) # .5, 1
penalty.start.alasso <- c(.5,1) # .9, 3
penalty.start.scad <- c(.1,1)
input.lasso <- list(penalty.fun=alasso,scalemle=TRUE,penalty.start=penalty.start.lasso)
input.alasso <- list(penalty.fun=alasso,scalemle=TRUE,penalty.start=penalty.start.alasso)
input.scad <- list(penalty.fun=scad,scalemle=FALSE,penalty.start=penalty.start.scad)

input <- list(lasso=input.lasso,alasso1=input.alasso,alasso2=input.alasso,scad=input.scad,nsim=500,penalize=penalize)

# cal starting value
out <- lm(do.call("rbind",y)~do.call("rbind",X)-1)
# tmp <- do.call("rbind",y)-do.call("rbind",X)%*%out$coef
control$start <- list(sigma2=1,theta=rbind(matrix(out$coef),matrix(ltvec(t(chol(diag(q)))),,1)))

if (pf==1)  {
	out <- lmeqfit(datasets[[1]],input,control,c("lasso"))
	save(out,file=paste("yaleoutlasso",Sys.Date(),".rdata",sep=""))
}
if (pf==2)  {	
	out <- lmeqfit(datasets[[1]],input,control,c("alasso1"))
	save(out,file=paste("yaleoutalasso",Sys.Date(),".rdata",sep=""))
}
if (pf==3)  {
	out <- lmeqfit(datasets[[1]],input,control,c("scad"))
	save(out,file=paste("yaleoutscad",Sys.Date(),".rdata",sep=""))
}
